//+------------------------------------------------------------------+
//|                                              MA_MACD_ADX_v01.mq4 |
//|                               Rohit Copyright  2010, AutoForEX. |
//|                                            rohit2712@yahoo.co.in |
//+------------------------------------------------------------------+
#property copyright "Rohit Copyright  2010, AutoForEX."
#property link      "rohit2712@yahoo.co.in"
/*The values can be altered as per the requirement. We can also add more indicators to this. But it will increase the number of functions. Any suggestions on hw to reduce the code..*/
//-----------MA---------------
extern double MPeriod1 = 5;                 // value for indicator. 0 to disable
extern double MPeriod2 = 17;                // value for indicator. 0 to disable
double FMA,SMA,PFMA,PSMA;
//------------macd------------
extern int FastEMA=12;                     // value for indicator. 0 to disable
extern int SlowEMA=26;                     // value for indicator. 0 to disable 
extern int SignalSMA=9;                    // value for indicator. 0 to disable
double MacdCurrent, MacdPrevious, SignalCurrent;
double SignalPrevious, MaCurrent, MaPrevious;
//-----------ADX--------------
extern int per_ADX=14;                     // value for indicator. 0 to disable
int ADX,pADX,ppdi,pmdi,nowpdi,nowmdi;
//-----------------common parameters-------------------
bool buycond=true;
bool sellcond=true;
extern double takeprofit = 4000;             //stoploss & takeprofit have been set very high. Can be changed according to requirement
extern double Stoploss = 4000;
extern double SLB,TPB,SLS,TPS;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----  

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  /*chosing the combination of indicators or indovidually*/
//----
   if(MPeriod1!=0 && MPeriod2!=0 && FastEMA==0 && SlowEMA==0 && SignalSMA==0 && per_ADX==0)MA();
   if(FastEMA!=0 && SlowEMA!=0 && SignalSMA!=0 && MPeriod1==0 && MPeriod2==0 && per_ADX==0)MACD();
   if(per_ADX!=0 && MPeriod1==0 && MPeriod2==0 && FastEMA==0 && SlowEMA==0 && SignalSMA==0)ADX();
   if(MPeriod1==0 && MPeriod2==0 && FastEMA!=0 && SlowEMA!=0 && SignalSMA!=0 && per_ADX!=0)MACDADX();
   if(MPeriod1!=0 && MPeriod2!=0 && FastEMA==0 && SlowEMA==0 && SignalSMA==0 && per_ADX!=0)ADXMA();
   if(MPeriod1!=0 && MPeriod2!=0 && FastEMA!=0 && SlowEMA!=0 && SignalSMA!=0 && per_ADX==0)MACDMA();   
   if(MPeriod1!=0 && MPeriod2!=0 && FastEMA!=0 && SlowEMA!=0 && SignalSMA!=0 && per_ADX!=0)ADXMACDMA();  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//-----------------------------Only Moving Average-----------------------------------
void MA()             //MA crossover EA
{

   int ticket=0;
   
   
   SLB=NormalizeDouble(Ask-Stoploss*Point,4);
   TPB=NormalizeDouble(Ask+takeprofit*Point,4);

   SLS=NormalizeDouble(Bid+Stoploss*Point,4);
   TPS=NormalizeDouble(Bid-takeprofit*Point,4);

    FMA=iMA(NULL,0,MPeriod1,0,MODE_SMA,PRICE_OPEN,0);
   SMA=iMA(NULL,0,MPeriod2,0,MODE_SMA,PRICE_OPEN,0);
   PFMA=iMA(NULL,0,MPeriod1,0,MODE_SMA,PRICE_OPEN,1);
   PSMA=iMA(NULL,0,MPeriod2,0,MODE_SMA,PRICE_OPEN,1);
  
    
    
    if(FMA>SMA && PFMA<PSMA && buycond==true)
    {
    checkclose();
    ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for MA
    if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
            Alert("BUY MA");
           }
         else
         {
          Print("Error opening BUY order : ",GetLastError());      
          RefreshRates();
          ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for MA
          }
    buycond=false;
    sellcond=true;
    }
    
    if(FMA<SMA && PFMA>PSMA && sellcond==true)
    {
    checkclose();
     ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MA
     if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
            Alert("SELL MA");
           }
         else 
         {
         Print("Error opening SELL order : ",GetLastError());  
         RefreshRates();
         ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MA
         }
   buycond=true;
   sellcond=false;
         
    }
    
}

void checkclose()
{
for(int i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=1986 || OrderSymbol()!=Symbol()) continue;
      if(OrderType()==OP_BUY)
      {
       if(FMA<SMA && PFMA>PSMA)
      {
     // if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);
      Print("Buy order closed");
      }
      break;
      }
      if(OrderType()==OP_SELL)
      {
      if(FMA>SMA && PFMA<PSMA)
      {
      //if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);     
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      Print("SELL order closed");
      }
      break;
      }

    }//close bracket for for loop
}// close bracket for checkclose
//------------------------------------------------------------------------------
//-------------------------Only MACD--------------------------------------------
void MACD()             //MACD EA
{
   int ticket=0;
   
   SLB=NormalizeDouble(Ask-Stoploss*Point,4);
   TPB=NormalizeDouble(Ask+takeprofit*Point,4);

   SLS=NormalizeDouble(Bid+Stoploss*Point,4);
   TPS=NormalizeDouble(Bid-takeprofit*Point,4);
   
   
   MacdCurrent=iMACD(NULL,0, FastEMA, SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0);
   SignalCurrent=iMACD(NULL,0, FastEMA, SlowEMA,SignalSMA,PRICE_OPEN,MODE_SIGNAL,0);
   MacdPrevious=iMACD(NULL,0, FastEMA, SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,1);
   SignalPrevious=iMACD(NULL,0, FastEMA, SlowEMA,SignalSMA,PRICE_OPEN,MODE_SIGNAL,1);
   MaCurrent=iMA(NULL,0,SignalSMA,0,MODE_EMA,PRICE_CLOSE,0);
   MaPrevious=iMA(NULL,0,SignalSMA,0,MODE_EMA,PRICE_CLOSE,1);
  
   if(MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious && MaCurrent>MaPrevious && buycond==true)
   {
    checkcloseMacd();
    ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for MACD
    if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
            Alert("BUY MACD");
           }
         else
         {
          Print("Error opening BUY order : ",GetLastError());      
          RefreshRates();
          ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for MACD
          }
    buycond=false;
    sellcond=true;
   }
   if(MacdCurrent<SignalCurrent && MacdPrevious>=SignalPrevious && MaCurrent<MaPrevious && sellcond==true)
   {
    checkcloseMacd();
    ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACD
    if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
            Alert("SELL MACD");
           }
         else 
         {
         Print("Error opening SELL order : ",GetLastError());  
         RefreshRates();
         ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACD
         }
   buycond=true;
   sellcond=false;
   }

}
void checkcloseMacd()
{
for(int n=OrdersTotal()-1;n>=0;n--)
     {
      if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=1986 || OrderSymbol()!=Symbol()) continue;
      if(OrderType()==OP_BUY)
      {
       if(MacdCurrent<SignalCurrent && MacdPrevious>=SignalPrevious && MaCurrent<MaPrevious)
      {
     // if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);
      Print("Buy order closed");
      }
      break;
      }
      if(OrderType()==OP_SELL)
      {
      if(MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious && MaCurrent>MaPrevious)
      {
      //if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);     
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      Print("SELL order closed");
      }
      break;
      }

    }//close bracket for for loop
}// close bracket for checkclose
//-------------------------------------------------------------------------------------------------

//-----------------------------------ONLY ADX------------------------------------------------------
void ADX() 
{
         int ticket=0;     
         
         SLB=NormalizeDouble(Ask-Stoploss*Point,4);
   TPB=NormalizeDouble(Ask+takeprofit*Point,4);

   SLS=NormalizeDouble(Bid+Stoploss*Point,4);
   TPS=NormalizeDouble(Bid-takeprofit*Point,4);
         
         
          ADX=iADX(Symbol(),0,per_ADX,PRICE_OPEN,MODE_MAIN,0);
          nowpdi=iADX(Symbol(),0,per_ADX,PRICE_OPEN,MODE_PLUSDI,0);
          nowmdi=iADX(Symbol(),0,per_ADX,PRICE_OPEN,MODE_MINUSDI,0);
     
         if(nowpdi>nowmdi && 40>ADX>20 && buycond==true)
          {
         
           checkcloseADX();
           ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for ADX
             if(ticket>0)
                {
                 if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
                   Alert("BUY ADX");
                }
            else
               {
                  Print("Error opening BUY order : ",GetLastError());      
                   RefreshRates();
                  ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for ADX
               }
             buycond=false;
            sellcond=true;
       }
       if(nowpdi<nowmdi && 40>ADX>20 && sellcond==true)
       {
       checkcloseADX();
       ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACD
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
            Alert("SELL ADX");
           }
         else 
         {
         Print("Error opening SELL order : ",GetLastError());  
         RefreshRates();
         ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACD
         }
      buycond=true;
      sellcond=false;
     }
}
void checkcloseADX()
{
for(int l=OrdersTotal()-1;l>=0;l--)
     {
      if(OrderSelect(l,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=1986 || OrderSymbol()!=Symbol()) continue;
      if(OrderType()==OP_BUY)
      {
      if(nowpdi<nowmdi) 
      {
     // if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);
      Print("Buy order closed");
      }
      break;
      }
      if(OrderType()==OP_SELL)
      {
      if(nowpdi>nowmdi)
      {
      //if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);     
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      Print("SELL order closed");
      }
      break;
      }

    }//close bracket for for loop
}// close bracket for checkclose
//--------------------------------------------------------------------------------------------
//-----------------------------------MACDADX-----------------------------------------------------
void MACDADX()
{
         int ticket=0;
         
         SLB=NormalizeDouble(Ask-Stoploss*Point,4);
   TPB=NormalizeDouble(Ask+takeprofit*Point,4);

   SLS=NormalizeDouble(Bid+Stoploss*Point,4);
   TPS=NormalizeDouble(Bid-takeprofit*Point,4);
         
           nowpdi=iADX(Symbol(),0,per_ADX,PRICE_OPEN,MODE_PLUSDI,0);
          nowmdi=iADX(Symbol(),0,per_ADX,PRICE_OPEN,MODE_MINUSDI,0);
          
          MacdCurrent=iMACD(NULL,0, FastEMA, SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0);
           SignalCurrent=iMACD(NULL,0, FastEMA, SlowEMA,SignalSMA,PRICE_OPEN,MODE_SIGNAL,0);
          
          
                  
          
          
          if(buycond==true && nowpdi>nowmdi && MacdCurrent>SignalCurrent)
          {
           checkcloseMACDADX();
           ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for MACDADX
             if(ticket>0)
                {
                 if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
                   Alert("BUY MACDADX");
                }
            else
               {
                  Print("Error opening BUY order : ",GetLastError());      
                   RefreshRates();
                  ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for MACDADX
               }
             buycond=false;
            sellcond=true;
           
       }
                     
       if(sellcond==true && nowpdi<nowmdi &&MacdCurrent<SignalCurrent)
       {
       checkcloseMACDADX();
       ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACDADX
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
            Alert("SELL MACDADX");
           }
         else 
         {
         Print("Error opening SELL order : ",GetLastError());  
         RefreshRates();
         ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACDADX
         }
      buycond=true;
      sellcond=false;
    }
}    
     
void checkcloseMACDADX()
{
for(int j=OrdersTotal()-1;j>=0;j--)
     {
      if(OrderSelect(j,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderMagicNumber()!=1986 || OrderSymbol()!=Symbol()) continue;
      if(OrderType()==OP_BUY)
      {
      if(nowpdi<nowmdi)// && MacdCurrent<SignalCurrent)
      {
     // if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);
      Print("Buy order closed");
      }
      break;
      }
      if(OrderType()==OP_SELL)
      {
      if(nowpdi>nowmdi)// && MacdCurrent>SignalCurrent)
      {
      //if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);     
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      Print("SELL order closed");
      }
      break;
      }

    }//close bracket for for loop
}// close bracket for checkclose
//--------------------------------------------------------------------------------------------
//--------------------- ADXMA------------------------------------------------------------
void ADXMA()
{
      int ticket=0;
      
      SLB=NormalizeDouble(Ask-Stoploss*Point,4);
   TPB=NormalizeDouble(Ask+takeprofit*Point,4);

   SLS=NormalizeDouble(Bid+Stoploss*Point,4);
   TPS=NormalizeDouble(Bid-takeprofit*Point,4);
        
   nowpdi=iADX(Symbol(),0,per_ADX,PRICE_OPEN,MODE_PLUSDI,0);
          nowmdi=iADX(Symbol(),0,per_ADX,PRICE_OPEN,MODE_MINUSDI,0);
   
    FMA=iMA(NULL,0,MPeriod1,0,MODE_SMA,PRICE_OPEN,0);
   SMA=iMA(NULL,0,MPeriod2,0,MODE_SMA,PRICE_OPEN,0);
      
             if(FMA>SMA && nowpdi>nowmdi && buycond==true)
                        {
                       checkcloseADXMA();
                       ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for ADX
                         if(ticket>0)
                            {
                             if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
                               Alert("BUY ADXMA");
                            }
                        else
                           {
                              Print("Error opening BUY order : ",GetLastError());      
                               RefreshRates();
                              ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for ADX
                           }
                         buycond=false;
                        sellcond=true;
                       }
                       
                       if(FMA<SMA && nowpdi<nowmdi && sellcond==true)
                       {
                       checkcloseADXMA();
                        ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACD
                          if(ticket>0)
                            {
                             if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
                             Alert("SELL ADXMA");
                            }
                          else 
                          {
                          Print("Error opening SELL order : ",GetLastError());  
                          RefreshRates();
                          ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACD
                          }
                       buycond=true;
                       sellcond=false;
                       }
}

void checkcloseADXMA()
{
for(int m=OrdersTotal()-1;m>=0;m--)
     {
      if(OrderSelect(m,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=1986 || OrderSymbol()!=Symbol()) continue;
      if(OrderType()==OP_BUY)
      {
     if(nowpdi<nowmdi)
      {
     // if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);
      Print("Buy order closed");
      }
      break;
      }
      if(OrderType()==OP_SELL)
      {
   if(nowpdi>nowmdi)
      {
      //if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);     
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      Print("SELL order closed");
      }
      break;
      }

    }//close bracket for for loop
}// close bracket for checkclose
//-----------------------------------------------------------------------------------------------
//--------------------------MACDMA-----------------------------------------------------
void MACDMA()
{
      int ticket=0;
      
      
      SLB=NormalizeDouble(Ask-Stoploss*Point,4);
   TPB=NormalizeDouble(Ask+takeprofit*Point,4);

   SLS=NormalizeDouble(Bid+Stoploss*Point,4);
   TPS=NormalizeDouble(Bid-takeprofit*Point,4);
      
        
   MacdCurrent=iMACD(NULL,0, FastEMA, SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0);
   SignalCurrent=iMACD(NULL,0, FastEMA, SlowEMA,SignalSMA,PRICE_OPEN,MODE_SIGNAL,0);
   
    FMA=iMA(NULL,0,MPeriod1,0,MODE_SMA,PRICE_OPEN,0);
   SMA=iMA(NULL,0,MPeriod2,0,MODE_SMA,PRICE_OPEN,0);
      
             if(FMA>SMA && MacdCurrent>SignalCurrent && buycond==true)
                        {
                       checkcloseMACDMA();
                       ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for ADX
                         if(ticket>0)
                            {
                             if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
                               Alert("BUY MACDMA");
                            }
                        else
                           {
                              Print("Error opening BUY order : ",GetLastError());      
                               RefreshRates();
                              ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for ADX
                           }
                         buycond=false;
                        sellcond=true;
                       }
                       
                       if(FMA<SMA && MacdCurrent<SignalCurrent && sellcond==true)
                       {
                       checkcloseMACDMA();
                        ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACD
                          if(ticket>0)
                            {
                             if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
                             Alert("SELL MACDMA");
                            }
                          else 
                          {
                          Print("Error opening SELL order : ",GetLastError());  
                          RefreshRates();
                          ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACD
                          }
                       buycond=true;
                       sellcond=false;
                       }
}

void checkcloseMACDMA()
{
for(int o=OrdersTotal()-1;o>=0;o--)
     {
      if(OrderSelect(o,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=1986 || OrderSymbol()!=Symbol()) continue;
      if(OrderType()==OP_BUY)
      {
     if(FMA<SMA && MacdCurrent<SignalCurrent)
      {
     // if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);
      Print("Buy order closed");
      }
      break;
      }
      if(OrderType()==OP_SELL)
      {
   if(FMA>SMA && MacdCurrent>SignalCurrent)
      {
      //if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);     
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      Print("SELL order closed");
      }
      break;
      }

    }//close bracket for for loop
}// close bracket for checkclose
//-----------------------------------------------------------------------------------------------

//--------------------------ADXMACDMA-----------------------------------------------------
void ADXMACDMA()
{
      int ticket=0;
      
      SLB=NormalizeDouble(Ask-Stoploss*Point,4);
   TPB=NormalizeDouble(Ask+takeprofit*Point,4);

   SLS=NormalizeDouble(Bid+Stoploss*Point,4);
   TPS=NormalizeDouble(Bid-takeprofit*Point,4);
      
      nowpdi=iADX(Symbol(),0,per_ADX,PRICE_OPEN,MODE_PLUSDI,0);
          nowmdi=iADX(Symbol(),0,per_ADX,PRICE_OPEN,MODE_MINUSDI,0);
        
   MacdCurrent=iMACD(NULL,0, FastEMA, SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0);
   SignalCurrent=iMACD(NULL,0, FastEMA, SlowEMA,SignalSMA,PRICE_OPEN,MODE_SIGNAL,0);
   
    FMA=iMA(NULL,0,MPeriod1,0,MODE_SMA,PRICE_OPEN,0);
   SMA=iMA(NULL,0,MPeriod2,0,MODE_SMA,PRICE_OPEN,0);
      
             if(FMA>SMA && MacdCurrent>SignalCurrent  && nowpdi>nowmdi && buycond==true)
                        {
                       checkcloseADXMACDMA();
                       ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for ADX
                         if(ticket>0)
                            {
                             if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
                               Alert("BUY MACDMA");
                            }
                        else
                           {
                              Print("Error opening BUY order : ",GetLastError());      
                               RefreshRates();
                              ticket=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,SLB,TPB,"",1986,0,Red); // open new BUY Order for ADX
                           }
                         buycond=false;
                        sellcond=true;
                       }
                       
                       if(FMA<SMA && MacdCurrent<SignalCurrent && nowpdi>nowmdi && sellcond==true)
                       {
                       checkcloseADXMACDMA();
                        ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACD
                          if(ticket>0)
                            {
                             if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
                             Alert("SELL MACDMA");
                            }
                          else 
                          {
                          Print("Error opening SELL order : ",GetLastError());  
                          RefreshRates();
                          ticket=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,SLS,TPS,"",1986,0,Blue);//open new Sell Order for MACD
                          }
                       buycond=true;
                       sellcond=false;
                       }
}

void checkcloseADXMACDMA()
{
for(int p=OrdersTotal()-1;p>=0;p--)
     {
      if(OrderSelect(p,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=1986 || OrderSymbol()!=Symbol()) continue;
      if(OrderType()==OP_BUY)
      {
     if(FMA<SMA && MacdCurrent<SignalCurrent)
      {
     // if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);
      Print("Buy order closed");
      }
      break;
      }
      if(OrderType()==OP_SELL)
      {
   if(FMA>SMA && MacdCurrent>SignalCurrent)
      {
      //if(OrderProfit()>=0)
      OrderClose(OrderTicket(),OrderLots(),Bid,3,Snow);     
      OrderClose(OrderTicket(),OrderLots(),Ask,3,Gold);
      Print("SELL order closed");
      }
      break;
      }

    }//close bracket for for loop
}// close bracket for checkclose
//-----------------------------------------------------------------------------------------------


